leetcode做题笔记907. 子数组的最小值之和

给定一个整数数组 arr,找到 min(b) 的总和,其中 b 的范围为 arr 的每个(连续)子数组。

由于答案可能很大,因此返回答案模 10^9 + 7 。

示例 1:

复制代码
输入:arr = [3,1,2,4]
输出:17
解释:
子数组为 [3],[1],[2],[4],[3,1],[1,2],[2,4],[3,1,2],[1,2,4],[3,1,2,4]。 
最小值为 3,1,2,4,1,1,2,1,1,1,和为 17。

示例 2:

复制代码
输入:arr = [11,81,94,43,3]
输出:444

提示:

  • 1 <= arr.length <= 3 * 104
  • 1 <= arr[i] <= 3 * 104

思路一:模拟题意

c++解法

cpp 复制代码
class Solution {
public:
    int sumSubarrayMins(vector<int>& arr) {
        int n = arr.size(), mod = 1e9 + 7, ans = 0;
        vector<int> s = {-1};
        for(int i = 0; i < n; ++i){
            while(s.size() > 1 && arr[s.back()] >= arr[i]){
                int cur = s.back(); s.pop_back();
                ans = (ans + 1LL * (i - cur) * (cur - s.back()) * arr[cur]) % mod; 
            }
            s.push_back(i);
        }
        while(s.size() > 1){
            int cur = s.back(); s.pop_back();
            ans = (ans + 1LL * (n - cur) * (cur - s.back()) * arr[cur]) % mod;
        }
        return ans;
    }
};

分析:

本题与前日的每日一题相似,需不断比较得到当前子数组中最小值并计算总和,利用数组存放递增的数,最后根据公式 ans = (ans + 1LL * (i - cur) * (cur - s.back()) * arrcur) % mod; 计算得到答案

总结:

本题考察对数组的应用,理解题意中前数对子数组的作用即可解决问题

相关推荐
reikocao13 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz13 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
夕除14 小时前
Redis 过期策略
redis·笔记·面试
吞下星星的少年·-·14 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
文丑颜不良啊14 小时前
LeetCode1481~1500题目解析
java·leetcode
文丑颜不良啊15 小时前
LeetCode1381~1400题目解析
java·leetcode
是main不是漫15 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
Nuanyt15 小时前
Agent 学习笔记(下篇三):上线工程、进阶选择与操作界面(Stage 7 / 7.5 / 8 + 延伸路线)
笔记·python·学习·memory·aiagent·harness
深圳市快瞳科技有限公司16 小时前
野外鸟类AI识别落地实录:输入适配、结构化输出、去重聚合与置信度分流的工程实践
算法·计算机视觉·鸟类识别·鸟类ai识别·野外鸟类观测·林业调查
叼烟扛炮16 小时前
Linux 学习笔记(四十一):TCP 并发演进——从单进程到多线程服务器
linux·运维·服务器·网络·笔记·学习·tcp/ip